unit PatchExtractor1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ShlObj, FileCtrl, IniFiles;

type
  TForm2 = class(TForm)
    btnReset: TButton;
    btnFirstScan: TButton;
    btnSecondScan: TButton;
    Label1: TLabel;
    txtFolder: TEdit;
    btnSelectFolder: TButton;
    Label2: TLabel;
    btnExtract: TButton;
    ProgressBar1: TProgressBar;
    Memo3: TMemo;
    Label3: TLabel;
    procedure btnResetClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnSelectFolderClick(Sender: TObject);
    procedure btnFirstScanClick(Sender: TObject);
    procedure btnSecondScanClick(Sender: TObject);
    procedure btnExtractClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

var
  BaseFolder: string;
  sl1, sl2: THashedStringList;

function FastIndexOf(sl:TStrings; str:string): Integer;
begin
  for Result := 0 to sl.Count - 1 do
    if CompareText(sl[Result], str) = 0 then Exit;
  Result := -1;
end;

procedure GetFiles(SPath,Mask:String;List:TStringList);
var
 counter:integer;
procedure GetNext;
var ff:TSearchRec;
    err:integer;
    dirpart:string;
begin

  err:=FindFirst(SPath+'\'+Mask,$37,ff);
  while err=0 do begin
       if (ff.Name<>'.')and (ff.Name<>'..') then begin

          if ((ff.Attr and $10)=$10) then begin
            SPath:=SPath+'\'+ff.name;
            GetNext;
            Delete(SPath,LastDelimiter('\',SPath),length(ff.Name)+1);
          end else begin
            dirpart := StringReplace(SPath, BaseFolder + '\', '', [rfReplaceAll, rfIgnoreCase]);
            dirpart := StringReplace(dirpart, BaseFolder, '', [rfReplaceAll, rfIgnoreCase]);
            if dirpart = '' then
              list.AddObject(ff.name,TObject(ff.Time))
            else
              list.AddObject(dirpart+'\'+ff.name,TObject(ff.Time));
            inc(counter);
            if counter = 1000 then begin
              if Form2.ProgressBar1.Max = 1000 then begin
                 Form2.ProgressBar1.StepIt();
                 if Form2.ProgressBar1.Max = Form2.ProgressBar1.Position then begin
                    Form2.ProgressBar1.Position := 0;
                 end;
              end else begin
                 Form2.ProgressBar1.StepBy(1000);
              end;
              counter := 0;
              Application.ProcessMessages();
            end;
          end;
       end;
       err:=FindNext(ff);
  end;
  findclose(ff);
end;
begin
  counter := 0;
  GetNext;
end;


procedure TForm2.FormCreate(Sender: TObject);
begin
  sl1 := THashedStringList.Create;
  sl2 := THashedStringList.Create;
  btnResetClick(nil);
end;

procedure TForm2.btnSelectFolderClick(Sender: TObject);
var
  BrowseInfo  : TBrowseInfo;
  PIDL        : PItemIDList;
  DisplayName : array[0..1000] of Char;
begin
  { initialize our TBrowseInfo structure }
  FillChar(BrowseInfo,SizeOf(BrowseInfo),#0);
  BrowseInfo.hwndOwner      := Handle;
  BrowseInfo.pszDisplayName := @DisplayName[0];
  BrowseInfo.lpszTitle      := ' ';
  BrowseInfo.ulFlags        := BIF_RETURNONLYFSDIRS;

  { diaplay browse folder set the return value to
    our itemlist }
  PIDL := SHBrowseForFolder(BrowseInfo);

  { get our directory form the itemlist, the
    DisplayName alone is just the directory name
    without the path }
  if Assigned(PIDL) then begin
    if SHGetPathFromIDList(PIDL, DisplayName) then
       txtFolder.Text := DisplayName
    else
       txtFolder.Text := '';
  end;

end;

procedure TForm2.btnResetClick(Sender: TObject);
begin
  btnReset.Enabled := false;
  btnFirstScan.Enabled := true;
  btnSecondScan.Enabled := false;
  btnExtract.Enabled := false;

  txtFolder.Text := '';
  ProgressBar1.Max := 100;
  ProgressBar1.Position := 0;

  sl1.Clear;
  sl2.Clear;
  Memo3.Lines.Clear;
end;

procedure TForm2.btnFirstScanClick(Sender: TObject);
begin
  if txtFolder.Text = '' then begin
    ShowMessage('  .');
    exit;
  end;

  btnFirstScan.Enabled := false;
  BaseFolder := txtFolder.Text;

  GetFiles(txtFolder.Text, '*.*', sl1);

  ProgressBar1.Max := sl1.Count - 1;
  ProgressBar1.Position := 0;

  btnReset.Enabled := true;
  btnSecondScan.Enabled := true;
end;


procedure TForm2.btnSecondScanClick(Sender: TObject);
var n,id:integer;
 counter,t1,t2:integer;
begin
  BaseFolder := txtFolder.Text;
  btnSecondScan.Enabled := false;
  GetFiles(txtFolder.Text, '*.*', sl2);

  ProgressBar1.Position := 0;
  for n := 0 to sl2.Count - 1 do begin
     inc(counter);

     if counter = 1000 then begin
        ProgressBar1.StepBy(1000);
        counter := 0;
        Application.ProcessMessages();
     end;

     id := sl1.IndexOf(sl2[n]);
     if (id >= 0) then begin
       t1 := integer(sl2.Objects[n]);
       t2 := integer(sl1.Objects[id]);
       if (t1 = t2) then
          continue;
     end;
     Memo3.Lines.Add(sl2[n]);
  end;

  if Memo3.Lines.Count = 0 then begin
    Memo3.Text := '  .';
    btnSecondScan.Enabled := true;
    ProgressBar1.Position := 0;
    sl2.Clear;
    exit;
  end;
  btnExtract.Enabled := true;
  txtFolder.Text := '';
end;

procedure TForm2.btnExtractClick(Sender: TObject);
var n,id:integer;
    filename, dirpart, newfilename:string;
begin
  if txtFolder.Text = '' then begin
    ShowMessage('  .');
    exit;
  end;
  for n := 0 to Memo3.Lines.Count - 1 do begin
     filename :=  BaseFolder + '\' + Memo3.Lines[n];
     newfilename := txtFolder.Text + '\' + Memo3.Lines[n];
     dirpart := Copy(newfilename, 0, LastDelimiter('\', newfilename));
     ForceDirectories(dirpart);
     CopyFile(pchar(filename),pchar(newfilename), false);
  end;

end;



end.
